#include <QGuiApplication>
#include <QQmlApplicationEngine>
#include <QQuickStyle>
#include <qbluetoothleuartclient.h>
#include <QTranslator>
#include <QFontDatabase>
#include <QQmlContext>

#ifdef Q_OS_ANDROID
#include <QtAndroidExtras>
#endif

#include "leddisplaybackend.h"

int main(int argc, char *argv[])
{
    QCoreApplication::setAttribute(Qt::AA_EnableHighDpiScaling);

    QCoreApplication::setOrganizationName("Itsblue");
    QCoreApplication::setOrganizationDomain("itsblue.de");
    QCoreApplication::setApplicationName("Itsblue smart display");

    QGuiApplication app(argc, argv);

    QTranslator translator;
    translator.load(":/" + QLocale::system().name() + ".qm");
    app.installTranslator(&translator);

    LedDisplayBackend::init();
    QBluetoothLeUartClient::init();

    QQuickStyle::setStyle("Material");

    QQmlApplicationEngine engine;
    engine.rootContext()->setContextProperty("APP_VERSION", APP_VERSION);
    const QUrl url(QStringLiteral("qrc:/main.qml"));
    QObject::connect(&engine, &QQmlApplicationEngine::objectCreated,
                     &app, [url](QObject *obj, const QUrl &objUrl) {
        if (!obj && url == objUrl)
            QCoreApplication::exit(-1);
    }, Qt::QueuedConnection);
    engine.load(url);

    return app.exec();
}
